import pandas as pd
import matplotlib.pyplot as plt
import numpy as np
from sklearn.model_selection import train_test_split
from sklearn import tree
from sklearn.tree import DecisionTreeRegressor
import sklearn.metrics as metrics

## Resample des données


# df_gaz = pd.read_csv('C:/Users/erwan/Documents/TP_Smart_System/Gaz_removed.csv', parse_dates=["time"], index_col="time")
# gaz_res = df_gaz.resample("1H").mean()
# gaz_res.to_csv('C:/Users/erwan/Documents/TP_Smart_System/Gaz_res.csv', index=False)
# #print(gaz_res)
#
# df_boiler = pd.read_csv('C:/Users/erwan/Documents/TP_Smart_System/Boiler_removed.csv', parse_dates=["time"], index_col="time")
# boiler_res = df_boiler.resample("1H").mean()
# boiler_res.to_csv('C:/Users/erwan/Documents/TP_Smart_System/Boiler_res.csv', index=False)
# #print(boiler_res)
#
# df_rain = pd.read_csv('C:/Users/erwan/Documents/TP_Smart_System/Rain_removed.csv', parse_dates=["time"], index_col="time")
# rain_res = df_rain.resample("1H").mean()
# rain_res.to_csv('C:/Users/erwan/Documents/TP_Smart_System/Rain_res.csv', index=False)
# #print(rain_res)
#
# df_temp = pd.read_csv('C:/Users/erwan/Documents/TP_Smart_System/Température_removed.csv', parse_dates=["time"], index_col="time")
# temp_res = df_temp.resample("1H").mean()
# temp_res.to_csv('C:/Users/erwan/Documents/TP_Smart_System/Temp_res.csv', index=False)

df_Temp = pd.read_csv('C:/Users/erwan/Documents/TP_Smart_System/Temp_res.csv')
df_Gaz = pd.read_csv('C:/Users/erwan/Documents/TP_Smart_System/Gaz_res.csv')
df_Boiler = pd.read_csv('C:/Users/erwan/Documents/TP_Smart_System/Boiler_res.csv')
df_Rain = pd.read_csv('C:/Users/erwan/Documents/TP_Smart_System/Rain_res.csv')

## On remplace les NaN par des 0

df_Temp = df_Temp.fillna(0)
df_Gaz = df_Gaz.fillna(0)
df_Boiler = df_Boiler.fillna(0)
df_Rain = df_Rain.fillna(0)

## Création de liste

Temp = df_Temp['value'].values.tolist()
Gaz = df_Gaz['value'].values.tolist()
Boiler = df_Boiler['value'].values.tolist()
Rain = df_Rain['value'].values.tolist()

print(len(Temp))
print(len(Gaz))
print(len(Rain))


time = []
for i in range(3341, 8760):
    time.append(i)

time2 = []
for i in range(6500, 7800):
    time.append(i)

# plt.plot(Temp[6342:7842], label='Température extérieure')
# plt.title("Température extérieure")
# plt.xlabel("Temps (H)")
# plt.ylabel("Température (°C)")
# plt.figure()
#
# plt.plot(Gaz[3000:4500])
# plt.title("Quantité de gaz utilisée")
# plt.xlabel("Temps (H)")
# plt.ylabel("Gaz (m3)")
# plt.figure()
#
# plt.plot(Rain[6342:7842])
# plt.title("Pluviométrie")
# plt.xlabel("Temps (H)")
# plt.ylabel("Pluie (mm)")
# plt.figure()

# plt.plot(Temp[6342:7842], label='Température')
# plt.plot(Gaz[3000:4500], label='Gaz')
# #plt.plot(Rain[6342:7842], label='Pluie')
# plt.xlabel("Temps (H)")
# plt.legend()


Temp_new = np.transpose(Temp[6342:7842])
Gaz_new = np.transpose(Gaz[3000:4500])
Rain_new = np.transpose(Rain[6342:7842])

ar = [Temp_new, Gaz_new, Rain_new]

data = pd.DataFrame(columns=['Temperature', "Gaz", "Rain"])
data['Temperature'] = Temp_new
data['Gaz'] = Gaz_new
data['Rain'] = Rain_new

print(data)

# Decision Tree

## Ne fonctione pas parce que variable continue et non discret

# x_train, x_test, y_train, y_test = train_test_split(data[['Temperature', 'Rain']], data[['Gaz']], test_size=0.3, random_state=0)
#
# clf = tree.DecisionTreeClassifier()
# clf = clf.fit(x_train, y_train)
# y_pred = clf.predict(x_test)
# tree.plot_tree(clf)
# with open("tree.dot", 'w') as f:
#  f = tree.export_graphviz(clf, out_file=f)


feature = []

Taille_training = int(0.7*len(Temp_new))

X = []
Y = []

for i in range (Taille_training):
    feature = [Temp_new[i], Rain_new[i]]
    X.append(feature)
    Y.append(Gaz_new[i])

regr = DecisionTreeRegressor(max_depth=3)
regr.fit(X, Y)
y = regr.predict(X)

with open("tree23.dot", "w") as file:
    f = tree.export_graphviz(regr, out_file=file)
